import usb

class ducky():
    def __init__(self):
        self.avr = self.setupAVR()
        self.set_led('ON')
        self.white = self.normalization()
        #print 'normalize level ' + str(shot)
    
    def isTrigger(self):
        if self.get_switch() == 'ON':
            mybool = True
        else: 
            mybool = False
        return mybool
    
    def isShot(self):
        return True if self.get_light() < self.white else False
        
    def setupAVR(self):
        avr = {}
        avr['board'] = self.find_board()
        avr['handle'] = avr['board'].open()
        avr['req_set'] = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
        avr['req_get'] = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
        return avr        
    
    def find_board(self):
        board = None
        for bus in usb.busses():
            for dev in bus.devices:
                if dev.idVendor == 0x16c0 and dev.idProduct == 0x05dc:
                    return dev
        return None

    def send_req(self,handle,req,led_no,stat):
        cmd = stat << 8 | led_no
        handle.controlMsg(req, 0, None, value=cmd)
        
    def read_req(self,handle,req,length,dev):        #dev> 1 = switch, 2 = light sensor
        return handle.controlMsg(req,dev,length)

    def set_led(self,s):
        if s == 'ON':
            self.send_req(self.avr['handle'],self.avr['req_set'],1,1)
        if s == 'OFF':
            self.send_req(self.avr['handle'],self.avr['req_set'],1,0)        
    
    def get_switch(self):
        s = self.read_req(self.avr['handle'],self.avr['req_get'],1,1)
        if s[0] == 1 :
            #print '|    Switch is currently ON'
            return 'ON'
        else:
            #print '|    Switch is currently OFF'
            return 'OFF'

    def get_light(self):
        s = self.read_req(self.avr['handle'],self.avr['req_get'],10,2)
        return s[0]+s[1]*256
           
    def normalization(self):
        print 'Normalization your gun to room light level'
        print 'Aim at white panel and shoot for a while'
        time = 1000
        for i in range(10):
            self.get_switch()
        while self.get_switch() == 'OFF':
            w = 0
        for i in range(time):
            w += self.get_light()
        w = w / time
        print 'Finish..!'
        while self.get_switch() == 'ON':
            time = 0
        return w+5

#Main program start here.
#duck = ducky()
#while(1):
    #if duck.get_switch() == 'ON':
   #     if light <= shot:
    #        print 'You shoot the DUCK!!',
     #       print '( ' + str(sum) + ' )'
      #  else:
       #     print 'Mai don!   Kee KaK..!',
        #    print '( ' + str(sum) +' )'
#    while get_switch(myAvr) == 'ON':
 #       light = 0
