import urllib
import pygame, sys,os 
from pygame.locals import *
from config import *
from render import *
from inputevent import *
from ducky import *


def load_sound(name):
    class NoneSound:
        def play(self): pass
    if not pygame.mixer:
        return NoneSound()
    fullname = os.path.join('data/sound', name)
    try:
        sound = pygame.mixer.Sound(fullname)
    except pygame.error, message:
        print 'Cannot load sound:, wav'
        raise SystemExit, message
    return sound


def main():
	LEVEL = 1
	state = 0
	ministate = 0
	score = 0
	pygame.init()
	pygame.mixer.init()
	clock = pygame.time.Clock()
	pygame.mouse.set_visible(False)
	somefont = pygame.font.Font(None,28)	# Create Font Family

	if FULLSCREEN:
		window = pygame.display.set_mode((512,450),pygame.FULLSCREEN) 	# Screen Resolution
	else:
		window = pygame.display.set_mode((512,450))#,pygame.FULLSCREEN) 	# Screen Resolution

	pygame.display.set_caption('Duck Hunt')	# Set title bar name 

	clock.tick(1)
	clock.tick(1)
	screen = pygame.display.get_surface()
	screen.fill((0,0,0))
	caribratefont = pygame.font.Font(None,28)	# Create Font Family
	text = caribratefont.render('Freeze Action',False,(255,255,255))

	block_surface = pygame.image.load(os.path.join("data/images","block.bmp"))	# Load pic to Memory
	screen.blit(block_surface, (210,210))
	screen.blit(text,(185,190))
	pygame.display.flip()
	usbstate = ducky()
	screen.fill((0,0,0))
	pygame.display.flip()
	while True:
		if state == STATE_MAIN:
			if ministate == STATE_MAIN_INIT:
				obj_logo = Logo()
				ministate = STATE_MAIN_SHOWING
			elif ministate == STATE_MAIN_SHOWING:
				ministate = obj_logo.fadein(clock.get_time(),ministate)
			elif ministate == STATE_MAIN_SHOWN:
				ministate = obj_logo.fadeout(clock.get_time(),ministate)
			elif ministate == STATE_MAIN_END_SHOWN:
				ministate = 0
				Init_Menu()
				state = STATE_MENU
		if state == STATE_STARTGAME:
			StartGame_Background(ministate)
			if ministate == STATE_STARTGAME_JUMPING:
				ministate = obj_dog.next(ministate,clock.get_time(),(10,268))
			elif ministate == STATE_STARTGAME_DOGCATCHING:
				ministate = obj_dogcatch.catchit(clock.get_time())
			elif ministate == STATE_STARTGAME_DOGLAUGHTING:
				ministate = obj_doglaught.laught(clock.get_time())
			StartGame_Slide()
			if ministate == STATE_STARTGAME_INIT:
				score = 0
				Init_StartGame()
				obj_duckpoint = Duckpoint()
				ministate = STATE_STARTGAME_DOGWALK
				obj_dog = Dog((10,283))
			elif ministate == STATE_STARTGAME_DOGWALK:
				ministate = obj_dog.next(ministate,clock.get_time(),(10,268))
			elif ministate == STATE_STARTGAME_SHOWROUND:
				obj_round = showround()
				ministate = STATE_STARTGAME_WAITROUND
			elif ministate == STATE_STARTGAME_WAITROUND:
				ministate = obj_round.next(clock.get_time())
			elif ministate == STATE_STARTGAME_START:
				obj_startturn = startturn((LEVEL*6)+4)		# Duck turn from 1 to 10 (all 10 turn)	, LEVEL IS ARGUMENT
				pygame.mixer.Sound(os.path.join('data/sound', 'prestart.wav')).play()
				ministate = STATE_STARTGAME_PREFLY
			elif ministate == STATE_STARTGAME_PREFLY:
				ministate = obj_startturn.waittheme(clock.get_time())
			elif ministate == STATE_STARTGAME_BIRD:
				ministate = obj_startturn.nextfly(clock.get_time())
			elif ministate == STATE_STARTGAME_SHOTBINGO:
				ministate = obj_startturn.shoted(True)
				obj_duckpoint.blink(clock.get_time())
			elif ministate == STATE_STARTGAME_SHOTMISS:
				ministate = obj_startturn.shoted(False)
			elif ministate == STATE_STARTGAME_BIRDFLYOUT:
				ministate = obj_startturn.flyout(clock.get_time())
			elif ministate == STATE_STARTGAME_BIRDDIE:
				ministate = obj_startturn.dieing(clock.get_time())
				obj_duckpoint.blink(clock.get_time())
			elif ministate == STATE_STARTGAME_DOGCATCH:
				obj_dogcatch = dogcatch()
				ministate = obj_duckpoint.score(state)
			elif ministate == STATE_STARTGAME_DOGLAUGHT:
				obj_doglaught = Doglaught()
				ministate = obj_duckpoint.cross(state)
			elif ministate == STATE_STARTGAME_VDO:
				state = STATE_GAMEOVER
				ministate = 0
			showscore(score)
			showlevel(LEVEL)
			obj_duckpoint.update()
			if ministate == STATE_STARTGAME_STARTSHOT:
				ministate = obj_startturn.shooting(clock.get_time())
		if state == STATE_GAMEOVER:
			if ministate == STATE_GAMEOVER_INITVDO:
				pygame.mixer.music.stop()
				pygame.mixer.quit()
				if FULLSCREEN:
					pygame.display.set_mode((352,450),pygame.FULLSCREEN)
				else:
					pygame.display.set_mode((352,450))
				mov = pygame.movie.Movie(os.path.join("data/media","video.mpg"))
				mov.play()
				ministate = STATE_GAMEOVER_WATCHING
			if ministate == STATE_GAMEOVER_WATCHING:
				if mov.get_busy() == False:
					ministate = STATE_GAMEOVER_FINVDO
			if ministate == STATE_GAMEOVER_FINVDO:
				pygame.mixer.init()
				if FULLSCREEN:
					window = pygame.display.set_mode((512,450),pygame.FULLSCREEN)
				else:
					window = pygame.display.set_mode((512,450))
				screen = pygame.display.get_surface()
				ministate = STATE_GAMEOVER_GAMEOVER
			if ministate == STATE_GAMEOVER_GAMEOVER:
				try:
					f = urllib.urlopen("http://www.alliance-dev.com/duckhunt/stats.php?python")
					parsestring = f.read()
					f.close()
				except:
					print 'cannot connect to server'
					parsestring = ""
				print parsestring
				ministate = STATE_GAMEOVER_SHOWSCORE
			if ministate == STATE_GAMEOVER_SHOWSCORE:
				screen = pygame.display.get_surface()
				screen.fill((0,0,0))
				showtext("::Top scores::",(130,45),40)
				#process top score
				topscoreline = parsestring.split('\n')
				for i in range(len(topscoreline)):
					name_score = topscoreline[i].split('\t')
					for j in range(len(name_score)):
						showtext(name_score[j],(50+(j*250),90+(20*i)))
				if score > 0:
					showtext("Press [Enter] to submit score",(130,340),16)
					showtext("You got total "+str(score)+" Point",(210,420))	# show score
			if ministate == STATE_GAMEOVER_UNINIT:
				pygame.mixer.quit()
				pygame.quit()
				ministate = STATE_GAMEOVER_SUBMIT
			if ministate == STATE_GAMEOVER_SUBMIT:
				stringinput = safeinput(raw_input())
				print 'Your name is : '+stringinput
				print 'submiting...'
				try:
					f = urllib.urlopen("http://www.alliance-dev.com/duckhunt/stats.php?name="+stringinput+"&score="+str(score))
					parsestring = f.read()
					f.close()
					print 'submited'
				except:
					print 'cannot connect to server'
				break
		if not (state == STATE_GAMEOVER and ministate == STATE_GAMEOVER_WATCHING):
				#showfps(clock)
				pygame.display.flip() 			# Render Screen
		tmpstate = input(pygame.event.get(),state,ministate)
		if state == STATE_STARTGAME and ministate == STATE_STARTGAME_BIRD:
			if usbstate.isTrigger() == True:
				pygame.mixer.Sound(os.path.join('data/sound', 'shoot.wav')).play()
				tmpstate = SHOOTING
		if state == STATE_STARTGAME and ministate == STATE_STARTGAME_REQ:
			ministate = STATE_STARTGAME_SHOTBINGO
			if usbstate.isShot() == True:
				ministate = STATE_STARTGAME_SHOTBINGO
				score += LEVEL*500
				LEVEL += 1
				obj_startturn.changelevel((LEVEL*5)+5)
			else:
				ministate = STATE_STARTGAME_SHOTMISS
				if LEVEL >1:
					LEVEL -= 1
					obj_startturn.changelevel((LEVEL*5)+5)
		if tmpstate == CHANGE_STATE_TO_STARTGAME:
			state = STATE_STARTGAME
			ministate = 0
		elif tmpstate == MISS:
			ministate = STATE_STARTGAME_SHOTMISS
		elif tmpstate == SHOOTING:
			ministate = STATE_STARTGAME_STARTSHOT
		elif tmpstate == PRESSVDO:
			mov.stop()
			ministate = STATE_GAMEOVER_FINVDO
		elif tmpstate == PRESSSUBMIT:
			if score > 0:
				ministate = STATE_GAMEOVER_UNINIT
		elif tmpstate == VIEWSCORE:
			state = STATE_GAMEOVER
			ministate = STATE_GAMEOVER_GAMEOVER
		clock.tick(60)
	print 'Good bye'


main()
