import random
import pygame, sys,os 
from pygame.locals import *
from config import *

def Init_Menu():
	bg_surface = pygame.image.load(os.path.join("data/images","menu.bmp"))	# Load pic to Memory
	screen = pygame.display.get_surface()
	screen.fill((0, 0, 0))						# Background = Black  , Clear all images
	screen.blit(bg_surface, (0,0))				# Place Pic to Screen
	

def Init_StartGame():
	pygame.mixer.music.set_volume(1.0)
	pygame.mixer.music.load(os.path.join('data/music', 'start.wav'))
	pygame.mixer.music.play()
	
def StartGame_Background(ministate):
	screen = pygame.display.get_surface()
	if(ministate==STATE_STARTGAME_BIRDFLYOUT):
		screen.fill((240,208,176))						# Background = Red  , Clear all images , in Event bird has left
	else:
		screen.fill((8, 214, 255))						# Background = Cyan  , Clear all images
	
	
def StartGame_Slide():
	bg_surface = pygame.image.load(os.path.join("data/images","background.png"))	# Load pic to Memory
	screen = pygame.display.get_surface()
	screen.blit(bg_surface, (0,0))				# Place Pic to Screen

class Logo():
	value = 0
	num = 0
	screen = pygame.display.get_surface()
	bg_surface = pygame.image.load(os.path.join("data/images","logo.bmp"))	# Load pic to Memory
	def __init__(self):
		self.screen = pygame.display.get_surface()
		pygame.mixer.music.set_volume(1.0)
		pygame.mixer.music.load(os.path.join('data/music', 'contra.wav'))
		pygame.mixer.music.play()
	def fadein(self,milisec,ministate):
		self.value += milisec
		if self.value > 10:
			self.value = 0
			if self.num<400:
				self.num+=3
			else:
				ministate = STATE_MAIN_SHOWN
		if self.num < 255:
			self.bg_surface.set_alpha(self.num)
		else:
			self.bg_surface.set_alpha(255)
		self.screen.fill((0,0,0))
		self.screen.blit(self.bg_surface, (92,0))				# Place Pic to Screen
		return ministate
	def fadeout(self,milisec,ministate):
		self.value += milisec
		if self.value > 10:
			self.value = 0
			if self.num>-100:
				self.num-=3
			else:
				ministate = STATE_MAIN_END_SHOWN
		if self.num>0:
			self.bg_surface.set_alpha(self.num)
		else:
			self.bg_surface.set_alpha(0)
		self.screen.fill((0,0,0))
		self.screen.blit(self.bg_surface, (92,0))				# Place Pic to Screen
		return ministate
class Dog():
	value = 0
	number = 0
	move = 0
	smell = 0
	walks = 0
	screen = pygame.display.get_surface()
	bg_surface = pygame.image.load(os.path.join("data/images","sprite.png"))	# Load pic to Memory
	def __init__(self,coordinate=(0,0)):
		self.screen = pygame.display.get_surface()
		self.screen.blit(self.bg_surface, coordinate,(0,0,120,90))				# Place Pic to Screen
	def next(self,num,milisec,coordinate=(0,0)):
		self.value += milisec
		if self.number < 14 and self.walks<2:
			self.move+=1
		coor = (coordinate[0]+self.move,coordinate[1])
		if self.value>80:
			self.number = (self.number+1)
			if self.walks<2:	# walking in 2 step
				if self.number >= 32:
					self.number = 0
					self.walks +=1
			self.value = 0
		if self.walks <2:
			if self.number/2 == 0 or self.number/2 == 4:
				list = (0,-9,120,118)
			elif self.number/2 == 1 or self.number/2 == 5:
				list = (120,-9,120,118)
			elif self.number/2 == 2 or self.number/2 == 6:
				list = (240,-9,120,118)
			elif self.number/2 == 3 or self.number/2 == 7 or self.number/2 == 8 or self.number/2 == 11 or self.number/2 == 12 or self.number/2 == 13 or self.number/2 == 14:
				list = (360,-9,120,118)
			elif self.number/2 == 9 or self.number/2 == 10 or self.number/2 == 13 or self.number/2 == 14 or self.number/2 == 15 or self.number/2 == 16:
				list = (482,-9,120,118)
		if self.walks == 2:
			if self.number == 0:
				pygame.mixer.Sound(os.path.join('data/sound', 'bark.wav')).play()
				self.number = 1
			if self.number < 5:
				list = (0,118,120,118)
			elif self.number < 12:
				coor = (coor[0]+(self.number-5)*4,coor[1]-(self.number-5)*13)
				list = (120,118,120,118)
			elif self.number < 20:
				coor = (coor[0]+(self.number)*4,coor[1]+(self.number-18)*13)
				list = (240,118,120,118)
				self.screen.blit(self.bg_surface, coor,list)				# Place Pic to Screen
				return STATE_STARTGAME_JUMPING
			else: 
				return STATE_STARTGAME_SHOWROUND
		self.screen.blit(self.bg_surface, coor,list)				# Place Pic to Screen
		return STATE_STARTGAME_DOGWALK
		
class showround():
	value = 0
	def render(self):
		round = pygame.image.load(os.path.join("data/images","round.png"))	# Load pic to Memory
		screen = pygame.display.get_surface()
		somefont = pygame.font.Font(None,28)	# Create Font Family
		text = somefont.render('Demo',False,(255,255,255))
		screen.blit(round, (210,180))				# Place Pic to Screen
		screen.blit(text,(230,210))
	def __init__(self):
		self.render()
	def next(self,milisec):
		self.value += milisec
		if self.value > 2000:
			self.value=0
			return STATE_STARTGAME_START
		self.render()
		return STATE_STARTGAME_WAITROUND
	
def showscore(score):
	somefont = pygame.font.Font(None,28)	# Create Font Family
	test = somefont.render(ScoreToStr(score),False,(255,255,255))		# show score
	screen = pygame.display.get_surface()
	screen.blit(test,(396,398))
	
def showlevel(LEVEL):
	somefont = pygame.font.Font(None,26)	# Create Font Family
	somefont.set_bold(True)
	test = somefont.render(str(LEVEL),False,(255,255,255))		# show score
	screen = pygame.display.get_surface()
	screen.blit(test,(80,367))
	
class startturn():
	turn = 0
	flystate = 0
	value = 0
	x = 0
	y = 0
	direct = 0
	level = 0
	flippoint = 0
	screen = pygame.display.get_surface()
	bg_surface = pygame.image.load(os.path.join("data/images","bird2.png"))	# Load pic to Memory
	def __init__(self,level):
		self.screen = pygame.display.get_surface()
		self.turn = 1
		self.level = level
		self.timeout = 0
		self.shootingtime = 0
		self.dietime = 0
		self.waitthemetime = 0
		self.dieface = LEFT
		pygame.mixer.music.set_volume(1.0)
		pygame.mixer.music.load(os.path.join('data/music', 'mario_.wav'))
		pygame.mixer.music.play(5)
	def changelevel(self,level):
		self.level = level
	def setfly(self):
		self.x = random.randint(1,430)
		self.y = 200
		self.direct = random.randint(LEFTUP,RIGHTUP)	# 0 to 1
		if self.direct == LEFTUP:
			self.fliplr()
	def fliplr(self):
		self.bg_surface = pygame.transform.flip(self.bg_surface, True, False)
	def nextfly(self,milisec):
		global TIME_BIRD_FLYING
		self.value += milisec
		if self.value > 100:
			self.value = 0
			self.timeout += 1
			if self.timeout%5 == 0:			
				pygame.mixer.Sound(os.path.join('data/sound', 'flying.wav')).play()
			if self.timeout > TIME_BIRD_FLYING:
				self.timeout = 0
				if self.direct == LEFTUP or self.direct == LEFTDOWN:
					self.direct = RIGHTUP
					self.fliplr()
				return STATE_STARTGAME_BIRDFLYOUT
			self.flystate=(1+self.flystate)%4
			if self.direct == RIGHTUP:
				if self.x>430:
					self.direct = LEFTUP
					self.fliplr()
				elif self.y<1:
					self.direct = RIGHTDOWN
				else:
					self.x = self.x + self.level
					self.y = self.y - self.level
			elif self.direct == LEFTUP:
				if self.x<1:
					self.direct = RIGHTUP
					self.fliplr()
				elif self.y<1:
					self.direct = LEFTDOWN
				else:
					self.x = self.x - self.level
					self.y = self.y - self.level
			elif self.direct == LEFTDOWN:
				if self.x<1:
					self.direct = RIGHTDOWN
					self.fliplr()
				elif self.y>200:
					self.direct = LEFTUP
				self.x = self.x - self.level
				self.y = self.y + self.level
			elif self.direct == RIGHTDOWN:
				if self.x>430:
					self.direct = LEFTDOWN
					self.fliplr()
				elif self.y>200:
					self.direct = RIGHTUP
				self.x = self.x + self.level
				self.y = self.y + self.level
		if self.flystate == 0:
			if self.direct == LEFTUP or self.direct == RIGHTUP:
				list = (0,80,80,80)
			else:
				list = (0,0,80,80)
		elif self.flystate == 1 or self.flystate == 3:
			if self.direct == LEFTUP or self.direct == RIGHTUP:
				list = (80,80,80,80)
			else:
				list = (80,0,80,80)
		elif self.flystate == 2:
			if self.direct == LEFTUP or self.direct == RIGHTUP:
				list = (160,80,80,80)
			else:
				list = (160,0,80,80)
		self.screen.blit(self.bg_surface, (self.x,self.y),list)
		return STATE_STARTGAME_BIRD
	def flyout(self,milisec):
		self.value += milisec
		if self.value > 100:
			self.value = 0
			self.flystate=(1+self.flystate)%4
			self.y -=10
			if self.y <-10:
				return STATE_STARTGAME_DOGLAUGHT
		if self.flystate == 0:
			list = (0,160,80,80)
		elif self.flystate == 1 or self.flystate == 3:
			list = (80,160,80,80)
		elif self.flystate == 2:
			list = (160,160,80,80)
		self.screen.blit(self.bg_surface, (self.x,self.y),list)
		return STATE_STARTGAME_BIRDFLYOUT
	def shooting(self,milisec):
		self.screen.fill((0,0,0))
		block_surface = pygame.image.load(os.path.join("data/images","block.bmp"))	# Load pic to Memory
		self.screen.blit(block_surface, (self.x,self.y))
		self.shootingtime += milisec
		if self.shootingtime > 70:
			self.shootingtime = 0
			return STATE_STARTGAME_REQ
		return STATE_STARTGAME_STARTSHOT
	def shoted(self,isshoted):
		if isshoted==True:
			self.timeout = 0	# clear fly time of old duck
			if self.direct == LEFTUP or self.direct == LEFTDOWN:
				self.direct = RIGHTUP
				self.fliplr()
			return STATE_STARTGAME_BIRDDIE
		else:
			return STATE_STARTGAME_BIRD
	def dieing(self,milisec):
		if self.dietime == 10:
			pygame.mixer.Sound(os.path.join('data/sound', 'getpoint.wav')).play()
			pygame.mixer.Sound(os.path.join('data/sound', 'drop.wav')).play()
		self.value += milisec
		if self.value > 100:
			self.value = 0
			self.dietime += 1
			if self.dietime >= 12:
				self.y += 10
				if self.y >210:
					self.dietime = 0
					if self.dieface==RIGHT:
						self.dieface = LEFT
						self.fliplr()
					return STATE_STARTGAME_DOGCATCH
		if self.dietime < 12:
			list = (0,240,80,80)
		else:
			list = (80,240,80,80)
			if (self.dietime/2)%2 == 0:
				if self.dieface == LEFT:
					self.dieface = RIGHT
				else:
					self.dieface = LEFT
				self.fliplr()
		self.screen.blit(self.bg_surface, (self.x,self.y),list)
		return STATE_STARTGAME_BIRDDIE
	def waittheme(self,milisec):
		self.waitthemetime += milisec
		if self.waitthemetime > 3500:
			self.waitthemetime = 0
			self.setfly()
			self.screen.blit(self.bg_surface, (self.x,self.y),(0,230,80,80))				# Place Pic to Screen
			return STATE_STARTGAME_BIRD
		elif self.waitthemetime > 2000:
			pygame.mixer.music.set_volume(0.6)
		return STATE_STARTGAME_PREFLY
		if self.dogtime < 12:
			list = (0,240,80,80)
		else:
			list = (80,240,80,80)
		self.screen.blit(self.bg_surface, (self.x,self.y),list)
		return STATE_STARTGAME_BIRDDIE

	
class dogcatch():
	def __init__(self):
		self.screen = pygame.display.get_surface()
		self.dogtime = 0
		self.value = 0
		self.x = 206
		self.y = 290
		self.bg_surface = pygame.image.load(os.path.join("data/images","sprite.png"))	# Load pic to Memory
	def catchit(self,milisec):
		self.value += milisec
		if self.value > 100:
			self.value = 0
			self.dogtime += 1
			if self.dogtime < 10:
				return STATE_STARTGAME_DOGCATCHING	# not show dog
			elif self.dogtime < 22:
				self.y -= 5
			if self.dogtime > 36:
				self.y += 5
			if self.dogtime > 50:
				self.dogtime = 0
				return STATE_STARTGAME_PREFLY
		if self.dogtime < 10:
			return STATE_STARTGAME_DOGCATCHING	# not show dog
		self.screen.blit(self.bg_surface, (self.x,self.y),(650,0,100,85))
		return STATE_STARTGAME_DOGCATCHING
		
class Doglaught():
	def __init__(self):
		self.screen = pygame.display.get_surface()
		self.dogtime = 0
		self.value = 0
		self.x = 206
		self.y = 290
		self.bg_surface = pygame.image.load(os.path.join("data/images","sprite.png"))	# Load pic to Memory		
		pygame.mixer.Sound(os.path.join('data/sound', 'laught.wav')).play()
	def laught(self,milisec):
		self.value += milisec
		if self.value > 100:
			self.value = 0
			self.dogtime += 1
			if self.dogtime < 10:
				return STATE_STARTGAME_DOGLAUGHTING	# not show dog
			elif self.dogtime < 22:
				self.y -= 5
			if self.dogtime > 36:
				self.y += 5
			if self.dogtime > 50:
				self.dogtime = 0
				return STATE_STARTGAME_PREFLY
		if self.dogtime < 10:
			return STATE_STARTGAME_DOGLAUGHTING	# not show dog
		if (self.dogtime/4)%2 == 0:
			list = (370,125,100,85)
		else:
			list = (470,125,100,85)
		self.screen.blit(self.bg_surface, (self.x,self.y),list)
		return STATE_STARTGAME_DOGLAUGHTING
		
class Duckpoint():
	def __init__(self):
		self.screen = pygame.display.get_surface()
		self.place = [0,0,0,0,0,0,0,0,0,0]
		self.value = 0
		self.toggle = True
		self.currentturn = 0
		self.duck_surface = pygame.image.load(os.path.join("data/images","duckpoint.png"))	# Load pic to Memory
	def blink(self,milisec):
		self.value += milisec
		if self.value > 200:
			self.value = 0
			if self.toggle == True:
				self.toggle = False
			else:
				self.toggle = True
		if self.toggle == True:
			self.screen.blit(self.duck_surface, (186+self.currentturn*16,395))
	def update(self):
		i=0
		while(i<self.currentturn):
			if self.place[i]==1:
				self.screen.blit(self.duck_surface, (186+i*16,395))
			i+=1
	def score(self,ministate):
		self.place[self.currentturn] = 1
		self.currentturn += 1
		if self.currentturn == 10:
			return STATE_STARTGAME_VDO
		else:
			return STATE_STARTGAME_DOGCATCHING
	def cross(self,ministate):	# shoot miss  not get point
		self.place[self.currentturn] = 0
		self.currentturn += 1
		if self.currentturn == 10:
			return STATE_STARTGAME_VDO
		else:
			return STATE_STARTGAME_DOGLAUGHTING

def showfps(Clock):
	screen = pygame.display.get_surface()
	font = pygame.font.Font(None,28)
	mystr = "%10.3f FPS" % Clock.get_fps()
	text = font.render(mystr,False,(255,255,255))		# show score
	screen = pygame.display.get_surface()
	screen.blit(text,(350,0))

def showtext(mystring,coor,size=28):
	itisfont = pygame.font.Font(None,size)
	textstring = itisfont.render(mystring,False,(255,255,255))		# show top score
	screen = pygame.display.get_surface()
	screen.blit(textstring,coor)


def safeinput(mystring):
	retstring = mystring.replace('<','')
	retstring = retstring.replace('>','')
	retstring = retstring.replace('\'','')
	retstring = retstring.replace('"','')
	retstring = retstring.replace('\\','')
	retstring = retstring.replace('\n','')
	retstring = retstring.replace('\r','')
	retstring = retstring.replace('\t','')
	retstring = retstring.replace('&','')
	return retstring
